include 'Zeropage.inc'
include 'Vram.inc'

pSource equ ZW0
pDestination equ ZW1
sourceOffset equ ZB0
destinationOffset equ ZB1
sourceByte equ ZB2
xCount equ ZB3


cseg
Multi8:
    sta <0,x
    lda #0 | sta <1,x
    asl <0,x | rol <1,x ;*2
    asl <0,x | rol <1,x ;*4
    asl <0,x | rol <1,x ;*8
rts

cseg
SetPatternMono:
    do
        ldy #0 | sty <sourceOffset | sty <destinationOffset
        do
            lda (<pSource),y | sta <sourceByte
            lda #2 | sta <xCount
            do
                ldy <destinationOffset
                lda #0 | sta (<pDestination),y
                ldx #4
                do
                    lda (<pDestination),y
                    asl a
                    asl a
                    sta (<pDestination),y

                    lda <sourceByte
                    and #$80
                    if ne
                        lda SetPatternMono_@Param2
                    else
                        lda #0
                    endif
                    ora (<pDestination),y
                    sta (<pDestination),y

                    asl <sourceByte
                    dex
                while ne | wend       
                iny
                sty <destinationOffset
                dec <xCount
            while ne | wend

            ldy <sourceOffset
            iny
            sty <sourceOffset
            cpy #4
        while ne | wend
        lda <pSource | clc|adc #4 | sta <pSource
        lda <pSource+1 | adc #0 | sta <pSource+1

        lda <pDestination | clc|adc #8 | sta <pDestination
        lda <pDestination+1 | adc #0 | sta <pDestination+1

        dec SetPatternMono_@Param3
    while ne | wend
rts

; void SetPatternMono(ptr<byte> pSource, byte pattern, byte color, byte count);
dseg
SetPatternMono_@Param0: public SetPatternMono_@Param0
    defw 0
SetPatternMono_@Param1: public SetPatternMono_@Param1
    defb 0
SetPatternMono_@Param2: public SetPatternMono_@Param2
    defb 0
SetPatternMono_@Param3: public SetPatternMono_@Param3
    defb 0
cseg
SetPatternMono_: public SetPatternMono_
    pha
        lda SetPatternMono_@Param0 | sta <pSource
        lda SetPatternMono_@Param0+1 | sta <pSource+1

        lda SetPatternMono_@Param1
        ldx #pDestination | jsr Multi8
        lda <pDestination | clc|adc #low CharRam | sta <pDestination
        lda <pDestination+1 | adc #high CharRam | sta <pDestination+1

        jsr SetPatternMono
    pla
rts


; ; void SetPatternColor(ptr<byte> pSource, byte pattern, byte count);
; dseg
; SetPatternColor_@Param0: public SetPatternColor_@Param0
;     defw 0
; SetPatternColor_@Param1: public SetPatternColor_@Param1
;     defb 0
; SetPatternColor_@Param2: public SetPatternColor_@Param2
;     defb 0
; cseg
; SetPatternColor_: public SetPatternColor_
;     pha
;         lda SetPatternColor_@Param0 | sta <pSource
;         lda SetPatternColor_@Param0+1 | sta <pSource+1

;         lda SetPatternColor_@Param1
;         ldx #pDestination | jsr Multi8
;         lda <pDestination | clc|adc #low CharRam | sta <pDestination
;         lda <pDestination+1 | adc #high CharRam | sta <pDestination+1
;         do

;             ldy #0
;             do
;                 lda (<pSource),y
;                 sta (<pDestination),y
;                 iny
;                 cpy #8
;             while ne | wend
;             lda <pSource | clc|adc #8 | sta <pSource
;             lda <pSource+1 | adc #0 | sta <pSource+1

;             lda <pDestination | clc|adc #8 | sta <pDestination
;             lda <pDestination+1 | adc #0 | sta <pDestination+1

;             dec SetPatternColor_@Param2
;         while ne | wend
;     pla
; rts



ext FortPattern_
dseg
FortPattern: public FortPattern
    defs CharHeight*6*6*4

; void InitFortPattern();
cseg
InitFortPattern_: public InitFortPattern_
    pha
        lda #low FortPattern_ | sta <pSource
        lda #high FortPattern_ | sta <pSource+1

        lda #low FortPattern | sta <pDestination
        lda #high FortPattern | sta <pDestination+1

        lda #2 | sta SetPatternMono_@Param2
        lda #6*6*4 | sta SetPatternMono_@Param3

        jsr SetPatternMono
    pla
rts


; void UpdateFortPattern();
Char_Fort equ $45
FortPatternDestination equ CharRam+CharHeight*Char_Fort
FortPatternSource00 equ FortPattern+CharHeight*6*6*0
FortPatternSource01 equ FortPattern+CharHeight*6*6*1
FortPatternSource10 equ FortPattern+CharHeight*6*6*2
FortPatternSource11 equ FortPattern+CharHeight*6*6*3
ext BaseX_, BaseY_;
cseg
UpdateFortPattern_: public UpdateFortPattern_
    pha
        lda BaseY_
        and #1
        if eq
            lda BaseX_
            and #1
            if eq
                lda #low FortPatternSource00 | sta <pSource
                lda #high FortPatternSource00 | sta <pSource+1
            else
                lda #low FortPatternSource01 | sta <pSource
                lda #high FortPatternSource01 | sta <pSource+1
            endif
        else
            lda BaseX_
            and #1
            if eq
                lda #low FortPatternSource10 | sta <pSource
                lda #high FortPatternSource10 | sta <pSource+1
            else
                lda #low FortPatternSource11 | sta <pSource
                lda #high FortPatternSource11 | sta <pSource+1
            endif
        endif
        lda #low FortPatternDestination | sta <pDestination
        lda #high FortPatternDestination | sta <pDestination+1
        ldy #0
        do
            lda (<pSource),y | sta (<pDestination),y
            iny
        while ne | wend
        inc <pSource+1 | inc <pDestination+1
        do
            lda (<pSource),y | sta (<pDestination),y
            iny
            cpy #CharHeight*6*6-$100
        while ne | wend
    pla
rts
