#include "Vram.h"
#include "Chars.h"

extern const byte[] MonoPattern;

static const byte[] PatternColorTable = {
    27, 3, // Ascii
    16, 2, // Logo
    4, 3, // Barrier
    2, 2, // Map
    20, 3, // Star Remain
    0xff
};

void InitVram()
{
    {
        byte pattern;
        ptr<byte> pSource, pPattern;
        pattern = 0;
        pSource = PatternColorTable;
        pPattern = MonoPattern;
        while (pSource[0] != 0xff) {
            byte count, color;
            count = *pSource; ++pSource;
            color = *pSource; ++pSource;
            SetPatternMono(pPattern, pattern, color, count);
            pattern += count;
            pPattern += ((word)count) << 2;
        }
    }
    InitFortPattern();
}


void VPut2(ptr<byte> pVram, byte pattern)
{
    repeat (2) {
        repeat (2) {
            *pVram = pattern; ++pVram;
            ++pattern;
        }
        pVram += VramWidth - 2;
    }
}


void VErase2(ptr<byte> pVram)
{
    repeat (2) {
        repeat (2) {
            *pVram = Char_Space; ++pVram;
        }
        pVram += VramWidth - 2;
    }
}


void VPut4(ptr<byte> pVram, ptr<byte> pBytes)
{
    repeat (4) {
        repeat (4) {
            *pVram = *pBytes; ++pVram;
            ++pBytes;
        }
        pVram += VramRowSize - 4;
    }
}


